// codDlg.cpp : implementation file
// Copyright(C) Sollae Systems Co.,Ltd.
// 11.Nov.2000 yyc  initial touch
//

#include "stdafx.h"
#include "ezsock.h"
#include "cod.h"
#include "codDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodDlg dialog

CCodDlg::CCodDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCodDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCodDlg)
	m_edit_port = 0;
	m_send_txt = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCodDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCodDlg)
	DDX_Control(pDX, IDC_CHECK_LF, m_check_lf);
	DDX_Control(pDX, IDC_CHECK_CR, m_check_cr);
	DDX_Control(pDX, IDC_EDIT_SEND, m_edit_send);
	DDX_Control(pDX, IDC_EDIT_CONSOLE, m_edit_console);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_button_send);
	DDX_Control(pDX, IDC_BUTTON_LISTEN, m_button_listen);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_button_exit);
	DDX_Control(pDX, IDC_BUTTON_DISCONNECT, m_button_disconnect);
	DDX_Text(pDX, IDC_EDIT_PORT, m_edit_port);
	DDV_MinMaxUInt(pDX, m_edit_port, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_SEND, m_send_txt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCodDlg, CDialog)
	//{{AFX_MSG_MAP(CCodDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, OnButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_LISTEN, OnButtonListen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodDlg message handlers

BOOL CCodDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_button_disconnect.EnableWindow(FALSE);	
	m_button_send.EnableWindow(FALSE);
	m_socket.m_app = (void *)this;
	m_new_socket.m_app = (void *)this;
	m_connected = FALSE;
	m_edit_port = 1470;
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCodDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCodDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCodDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCodDlg::OnButtonListen()
{
	CString msg;

	UpdateData(TRUE);
	m_socket.Create(m_edit_port);
	if(!m_socket.Listen(1))
	{
		msg.Format("Listen fail : error code %d\r\n", GetLastError());
		m_edit_console.ReplaceSel(msg);
		m_socket.Close();
		return;
	}
	DlgChangeButton(BUTTON_STATE_ACCEPT);
	msg.Format("Listening on tcp port %u....", m_edit_port);
	m_edit_console.ReplaceSel(msg);
}

void CCodDlg::OnButtonDisconnect() 
{
	if(m_connected)
	{
		m_new_socket.Close();
		m_edit_console.ReplaceSel("Close connection.\r\n");
	}
	else
	{
		m_socket.Close();
		m_edit_console.ReplaceSel("Accept stopped.\r\n");
	}
	DlgChangeButton(BUTTON_STATE_INITIAL);
}

void CCodDlg::OnButtonSend() 
{
	char buf[128];
	
	UpdateData(TRUE);

	m_new_socket.Send(m_send_txt, m_send_txt.GetLength(), 0);

	if(m_check_cr.GetCheck())
	{
		buf[0] = 0x0d;
		m_new_socket.Send(buf, 1 ,0);
	}
	if(m_check_lf.GetCheck())
	{
		buf[0] = 0x0a;
		m_new_socket.Send(buf, 1 ,0);
	}
	

	UpdateData(FALSE);
}


void CCodDlg::OnButtonExit() 
{
	PostQuitMessage(0);	
}

CString CCodDlg::addr2str(CIPAddressCtrl& ip_addr)
{
	BYTE a0, a1, a2, a3;
	CString addrstr;
	
	ip_addr.GetAddress(a0, a1, a2, a3);
	addrstr.Format("%u.%u.%u.%u", a0, a1, a2, a3);
	return addrstr;
}

void CCodDlg::DlgChangeButton(int state)
{
	switch(state)
	{
		case BUTTON_STATE_INITIAL:
			m_button_listen.EnableWindow(TRUE);
			m_button_disconnect.SetWindowText("DISCONNECT");
			m_button_disconnect.EnableWindow(FALSE);
			m_button_send.EnableWindow(FALSE);
			break;
		case BUTTON_STATE_ACCEPT:
			m_button_listen.EnableWindow(FALSE);
			m_button_disconnect.SetWindowText("STOP");
			m_button_disconnect.EnableWindow(TRUE);
			m_button_send.EnableWindow(FALSE);
			break;
		case BUTTON_STATE_CONNECTED:
			m_button_listen.EnableWindow(FALSE);
			m_button_disconnect.SetWindowText("DISCONNECT");
			m_button_disconnect.EnableWindow(TRUE);
			m_button_send.EnableWindow(TRUE);
			break;
	}
}

// Callback functions
void CCodDlg::DlgOnConnect(CEzSock *sock, int nErrorCode)
{
}

void CCodDlg::DlgOnAccept(CEzSock *sock, int nErrorCode)
{
	SOCKADDR_IN saddr;
	CString msg;

	if(nErrorCode || !m_socket.Accept(m_new_socket, (SOCKADDR *)&saddr))
	{
		msg.Format("Accept fail.\r\n");
		m_edit_console.ReplaceSel(msg);
		return;
	}
	else
	{
		m_edit_console.ReplaceSel("Accept new connection.\r\n");
		m_connected = TRUE;
	}
	sock->Close();
	DlgChangeButton(BUTTON_STATE_CONNECTED);
}

void CCodDlg::DlgOnReceive(CEzSock *sock, int nErrorCode)
{
	int len, count;
	CString msg;
	BYTE buf[1024];

	if(nErrorCode)
	{
	}
	else
	{
		len = sock->Receive(buf, 1024, 0);
		for(count = 0; count < len; count++)
		{
			msg = buf[count];
			m_edit_console.ReplaceSel(msg);
		}
	}
}

void CCodDlg::DlgOnClose(CEzSock *sock, int nErrorCode)
{
	sock->Close();
	m_edit_console.ReplaceSel("Connection closed.\r\n");
	DlgChangeButton(BUTTON_STATE_INITIAL);
}

